#include <iostream>
#include <algorithm>
#include <string>
#include <windows.h>
#include <oleauto.h>

#import "C:\\Program Files\\Microsoft Office\\Office10\\EXCEL.EXE" \
    raw_interfaces_only, raw_dispinterfaces, \
    no_dual_interfaces, no_smart_pointers, auto_rename, \
    exclude("Picture", "ColorFormat", "PictureFormat")


int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
        LPSTR lpCmdLine, int nCmdShow)
{
    CoInitialize(NULL);
    CLSID ExcelClassID;
    HRESULT nRet = CLSIDFromString(L"Excel.Application", &ExcelClassID);
    if (nRet != S_OK) return nRet;
            
    Excel::_Application * xlApp = NULL;
    HWND xlHandle = FindWindow("XLMAIN", NULL);
    if (xlHandle != NULL)
    {
        IUnknown * pUnk = NULL;
        nRet = GetActiveObject(ExcelClassID, NULL, &pUnk);
        if (nRet != S_OK)
        {
            MessageBox(NULL, "Temporary message box", NULL, MB_OK);
            Sleep(50);
            nRet = GetActiveObject(ExcelClassID, NULL, &pUnk);
        }


        if (nRet == S_OK)
        {
            nRet = pUnk->QueryInterface(__uuidof(Excel::_Application), (void**)&xlApp);
            if (nRet != S_OK) xlApp = NULL; 
            pUnk->Release();
            pUnk = NULL;
        }
    }

    if (xlApp != NULL)
    {
        char * url = lpCmdLine; //argv[argc-1];
        size_t urlLength = strlen(url);
        char urlProto[] = "excel://";

        if (std::equal(&urlProto[0], &urlProto[8], &url[0]))
        {
            VARIANT vntMissing; VariantInit(&vntMissing);
            vntMissing.vt = VT_ERROR;
            vntMissing.scode = DISP_E_PARAMNOTFOUND;

            bool isRange = false;
            try {
                if (url[urlLength-1] == '/') --urlLength;
                
                Excel::Range * rng = xlApp->get_Range(std::string(&url[8], &url[urlLength]).c_str(), vntMissing);
                Excel::_Worksheet * ws = rng->get_Worksheet();
                ws->Activate();
                rng->Activate();
                isRange = true;
                ws->Release();
                rng->Release();
            } catch(...)
            {
            }

            if (!isRange)
            {
                char * begin = (url[8] == '\'') ? &url[9] : &url[8];
                char * end = (url[urlLength-1] == '/') ? &url[urlLength-1] : &url[urlLength];
                end = (*(end-1) == '!') ? end-1 : end;
                end = (*(end-1) == '\'') ? end-1 : end;
                
                std::string workbook, sheet;
                if (*begin == '[')
                {
                    char * workbookEnd = std::find(begin, end, ']');
                    workbook = std::string(begin+1, workbookEnd);
                    begin = workbookEnd+1;
                }

                sheet = std::string(begin, end);
                try {
                    if (workbook.size() > 0)
                    {
                        Excel::Workbooks * wbs = xlApp->get_Workbooks();
                        Excel::_Workbook * wb = wbs->get_Item(workbook.c_str());
                        wb->Activate();
                        wb->Release();
                        wbs->Release();
                    }
                    Excel::Sheets * shs = xlApp->get_Sheets();
                    IDispatch * pdisp = shs->get_Item(sheet.c_str());
                    
                    OLECHAR* Name = L"Activate";
                    DISPID ID;
                    nRet = pdisp->GetIDsOfNames(IID_NULL, &Name, 1, LOCALE_SYSTEM_DEFAULT, &ID);
                    if (nRet == S_OK)
                    {
                        DISPPARAMS Params = {NULL, NULL, 0, 0};
                        nRet = pdisp->Invoke(ID, IID_NULL, LOCALE_SYSTEM_DEFAULT, DISPATCH_METHOD, 
                                &Params, NULL, NULL, NULL);
                        if (nRet != S_OK)
                        {
                        }
                    }
                    
                    pdisp->Release();
                    shs->Release();
                } catch(...)
                {
                }
            }
        } else
        {
        }

        xlApp->Release();
    }
    CoUninitialize();
    return nRet;
}


